﻿using System; 
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace Garage
{
    public partial class MainForm : Form
    {
        public MainForm()
        {
            InitializeComponent();

            //lol.Select(i => (i + 1)).Where(i => i > 10);
        }

        //Pokud nevite o co jde, jde o nic
        //List<int> lol = new List<int>();

        public void BuyNewCar(object sender, EventArgs e)
        {
            CarDialog diag = new CarDialog();

            if (diag.ShowDialog() == DialogResult.OK)
            {
                carListBox.Items.Add(diag.Car);
            }
        }

        public void SellCar(object sender, EventArgs e)
        {
            carListBox.Items.RemoveAt(carListBox.SelectedIndex);
        }

        public void ModifyCar(object sender, EventArgs e)
        {
            CarDialog diag = new CarDialog();
            diag.Car = (carListBox.SelectedItem as Car);

            if (diag.ShowDialog() == DialogResult.OK)
            {
                int index = carListBox.SelectedIndex;
                carListBox.Items.RemoveAt(index);

                carListBox.Items.Insert(index, diag.Car);
            }
        }

        private void newGarageToolStripMenuItem_Click(object sender, EventArgs e)
        {
            carListBox.Items.Clear();
        }

        private void quitToolStripMenuItem_Click(object sender, EventArgs e)
        {
            Close();
        }

        private void carListBox_SelectedValueChanged(object sender, EventArgs e)
        {
            if (carListBox.SelectedItem == null)
            {
                panel.Visible = false;
                modifyToolStripMenuItem.Enabled = false;
                modifyCarButton.Enabled = false;
                sellToolStripMenuItem.Enabled = false;
                sellCarButton.Enabled = false;
            }
            else
            {
                panel.Visible = true;
                modifyToolStripMenuItem.Enabled = true;
                modifyCarButton.Enabled = true;
                sellToolStripMenuItem.Enabled = true;
                sellCarButton.Enabled = true;

                Car selectedCar = (carListBox.SelectedItem as Car);

                nameLabel.Text = String.Format("\"{0}\"", selectedCar.Name);

                manufacturerLabel.Text = selectedCar.Manufacturer;
                priceLabel.Text = String.Format("{0:0.00} €", selectedCar.Price);

                colourButton.BackColor = selectedCar.Colour;
            }
        }

        private void saveGarageToolStripMenuItem_Click(object sender, EventArgs e)
        {
            SaveFileDialog diag = new SaveFileDialog();

            diag.AddExtension = true;
            diag.DefaultExt = "txt";
            diag.Filter = "Text File (*.txt)|*.txt|Garage File (*.grg)|*.grg";
            diag.InitialDirectory = Environment.CurrentDirectory;

            if (diag.ShowDialog() == DialogResult.OK)
            {
                string file = diag.FileName;

                using (StreamWriter sw = new StreamWriter(file))
                {
                    foreach (object item in carListBox.Items)
                    {
                        Car car = (item as Car);

                        sw.WriteLine("{0};{1};{2};{3};{4}", car.Manufacturer, car.Name, car.LicensePlate,
                            car.Price, car.Fuel);
                    }
                }

                //sw.Flush();
                //sw.Dispose();
            }
        }

        private void loadGarageToolStripMenuItem_Click(object sender, EventArgs e)
        {
            OpenFileDialog diag = new OpenFileDialog();

            diag.Filter = "Text File (*.txt)|*.txt|Garage File (*.grg)|*.grg|All Files (*.*)|*.*";
            diag.InitialDirectory = Environment.CurrentDirectory;

            if (diag.ShowDialog() == DialogResult.OK)
            {
                carListBox.Items.Clear();

                using (StreamReader sr = new StreamReader(diag.FileName))
                {
                    string line;
                    decimal price;
                    decimal fuel;

                    while ((line = sr.ReadLine()) != null)
                    {
                        string[] carInfo = line.Split(';');

                        price = Decimal.Parse(carInfo[3]);
                        fuel = Decimal.Parse(carInfo[4]);

                        Car car = new Car(carInfo[0], carInfo[2], price)
                        {
                            Name = carInfo[1],
                            Fuel = fuel
                        };

                        carListBox.Items.Add(car);
                    }
                }
            }
        }
    }
}
